---
title: HTMLSourceElement
slug: Web/API/HTMLSourceElement
tags:
  - API
  - HTML DOM
  - Interface
  - Reference
---
<div>{{APIRef("HTML DOM")}}</div>

<p>The <strong><code>HTMLSourceElement</code></strong> interface provides special properties (beyond the regular {{domxref("HTMLElement")}} object interface it also has available to it by inheritance) for manipulating {{htmlelement("source")}} elements.</p>

<p>{{InheritanceDiagram(600, 120)}}</p>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its parent, {{domxref("HTMLElement")}}.</em></p>

<dl>
 <dt>{{domxref("HTMLSourceElement.media")}}</dt>
 <dd>Is a {{domxref("DOMString")}} reflecting the {{ htmlattrxref("media", "source") }} HTML attribute, containing the intended type of the media resource.</dd>
 <dt>{{domxref("HTMLSourceElement.sizes")}} {{experimental_inline}}</dt>
 <dd>Is a {{domxref("DOMString")}} representing image sizes between breakpoints</dd>
 <dt>{{domxref("HTMLSourceElement.src")}}</dt>
 <dd>Is a {{domxref("DOMString")}} reflecting the {{ htmlattrxref("src", "source") }} HTML attribute, containing the URL for the media resource. The {{domxref("HTMLSourceElement.src")}} property has a meaning only when the associated {{HTMLElement("source")}} element is nested in a media element that is a {{htmlelement("video")}} or an {{htmlelement("audio")}} element. It has no meaning and is ignored when it is nested in a {{HTMLElement("picture")}} element.
 <div class="note"><strong>Note</strong>: If the <code>src</code> property is updated (along with any siblings), the parent {{domxref("HTMLMediaElement")}}'s <code>load</code> method should be called when done, since <code>&lt;source&gt;</code> elements are not re-scanned automatically.</div>
 </dd>
 <dt>{{domxref("HTMLSourceElement.srcset")}} {{experimental_inline}}</dt>
 <dd>Is a {{domxref("DOMString")}} reflecting the {{ htmlattrxref("srcset", "source") }} HTML attribute, containing a list of candidate images, separated by a comma (<code>',', U+002C COMMA</code>). A candidate image is a URL followed by a <code>'w'</code> with the width of the images, or an <code>'x'</code> followed by the pixel density.</dd>
 <dt>{{domxref("HTMLSourceElement.type")}}</dt>
 <dd>Is a {{domxref("DOMString")}} reflecting the {{ htmlattrxref("type", "source") }} HTML attribute, containing the type of the media resource.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>No specific method; inherits methods from its parent, {{domxref("HTMLElement")}}.</em></p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "#htmlsourceelement", "HTMLSourceElement")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLSourceElement")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The HTML element implementing this interface: {{ HTMLElement("source") }}.</li>
 <li>The HTML DOM APIs of the elements that can contain a {{HTMLElement("source")}} element: {{domxref("HTMLVideoElement")}}, {{domxref("HTMLAudioElement")}}, {{domxref("HTMLPictureElement")}}.</li>
</ul>
